import pandas as pd
import tkinter as tk
import tkinter.ttk as ttk
import matplotlib.pyplot as plt
import  seaborn as sns
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg

""" go put the manage class into ManageRecords.py when done"""
class Facade(tk.Tk):

    def __init__(self):
        super().__init__()
        self.title("Main Menu")
        self.menu()

    def menu(self):
        self.home = Menu(self)
        self.home.run()

    def run(self):
        self.mainloop()

class Menu(ttk.Frame):
    def __init__(self,parent):
        super().__init__(parent)
        self.parent = parent
        self.pack()
        self.canvas = tk.Canvas(self, width=1080 , height = 608 , background='#D45438')
        self.canvas.pack(fill='both', expand = True)
        # self.frame = tk.Frame(self.canvas)
        self.custom_style = ttk.Style()
        self.custom_style.configure("Custom.TButton", background="grey", foreground="white" , font="Ubuntu, 24 " , relief="flat")
        self.quit_style = ttk.Style()
        self.create_widgets()
        self.btnQuit = ttk.Button(self, text="Quit", command=parent.destroy)
        self.btnQuit.pack()
    def create_widgets(self):
        label1 = tk.Label(self.canvas, text="Youtube Statistics",background="#D45438" , foreground="white",font= "PrintAble4U, 30")
        label1.place(x=415, y=50)
        button1 = ttk.Button(self.canvas, text="Videos", command=self.view_videos, style="Custom.TButton")
        button1.place(x=430, y=170)
        button2 = ttk.Button(self.canvas, text="Channels", command=self.view_channels, style="Custom.TButton")
        button2.place(x=430, y=310)
        button3 = ttk.Button(self.canvas, text="Search \nChannel", command=self.view_specific_channel, style="Custom.TButton")
        button3.place(x=430, y=450)
    def view_videos(self):
        self.destroy()
        Option(self.parent, 1)
    def view_channels(self):
        self.destroy()
        Option(self.parent, 2)
    def view_specific_channel(self):
        self.destroy()
        Option(self.parent,3)
    # def open_second_tab(self):
    #     self.option = 3

    def run(self):
        self.mainloop()

class Option(ttk.Frame):
    def __init__(self,parent,number : int):
        super().__init__(parent)
        self.parent = parent
        self.orig_df = pd.read_csv("USvideos.csv")
        self.df = self.orig_df.copy()
        # self.content_frame = ttk.Frame(self.canvas)

        if number == 1:
            self.videos_opt()
            self.backBtn = ttk.Button(self, text="Back", command=self.back2)
        elif number ==2:
            self.channel_opt()
            self.backBtn = ttk.Button(self, text="Back", command=self.back2)
        elif number == 3:
            self.search_opt()
            self.backBtn = ttk.Button(self, text="Back", command=self.back1)
        self.backBtn.pack()
        self.pack()
    def videos_opt(self):
        self.scrollable_frame = ttk.Frame(self.parent)
        self.scrollable_frame.pack(fill=tk.BOTH, expand=True)

        self.canvas = tk.Canvas(self.scrollable_frame, width=1080 , height = 608)
        self.canvas.pack(side=tk.LEFT, fill=tk.BOTH, expand=True)

        self.scrollbar = ttk.Scrollbar(self.scrollable_frame, orient=tk.VERTICAL, command=self.canvas.yview)
        self.scrollbar.pack(side=tk.RIGHT, fill=tk.Y)

        self.canvas.configure(yscrollcommand=self.scrollbar.set)
        self.canvas.bind("<Configure>", lambda e: self.canvas.configure(scrollregion=self.canvas.bbox("all")))

        self.content_frame = ttk.Frame(self.canvas)
        self.canvas.create_window((0, 0), window=self.content_frame, anchor="nw")
        self.create_graph1(self.df[['views']].copy(), 'views Histogram', 'views/video ( x 10^6)', 'Frequency','views')
        grouped_df1 = self.df.groupby('title', as_index=False)['views'].sum()
        self.create_graph2(grouped_df1, 'top viewed video', 'views', 'title')
    def channel_opt(self):
        self.scrollable_frame = ttk.Frame(self.parent)
        self.scrollable_frame.pack(fill=tk.BOTH, expand=True)

        self.canvas = tk.Canvas(self.scrollable_frame, width=1080 , height = 608)
        self.canvas.pack(side=tk.LEFT, fill=tk.BOTH, expand=True)

        self.scrollbar = ttk.Scrollbar(self.scrollable_frame, orient=tk.VERTICAL, command=self.canvas.yview)
        self.scrollbar.pack(side=tk.RIGHT, fill=tk.Y)

        self.canvas.configure(yscrollcommand=self.scrollbar.set)
        self.canvas.bind("<Configure>", lambda e: self.canvas.configure(scrollregion=self.canvas.bbox("all")))

        self.content_frame = ttk.Frame(self.canvas)
        self.canvas.create_window((0, 0), window=self.content_frame, anchor="nw")
        grouped_df = self.df.groupby('channel_title', as_index=False)['views'].sum()
        self.create_graph1(grouped_df[['views']].copy(), 'views Histogram', 'views/video ( x 10^6)', 'Frequency','views')
        self.create_graph2(grouped_df, 'top view per channel', 'views', 'channel_title')
    def create_graph1(self, df , title, x_label, y_label,value):
        # temp_df = df.select_dtypes(include=['int', 'float']).copy()
        self.get_cleaned_dataframe(df)
        fig = plt.Figure(figsize=(10.8,6.08),dpi=100)
        ax = fig.add_subplot(111)
        ax.hist(self.cleaned_df[value])
        ax.set_title(title)
        ax.set_xlabel(x_label)
        ax.set_ylabel(y_label)
        canvas = FigureCanvasTkAgg(fig, master=self.content_frame)
        canvas.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=True)
    def create_graph2(self, df , title, x_label, y_label):
        # self.get_cleaned_dataframe(df)
        """ for god know whatever the reason , this thing just can't be cleaned here
            tried it on google collab , work perfetcly fine I'll also submit that file
            (I wasted 3 hours on this)
        """
        top_df = df.nlargest(20, x_label)
        sort_df = top_df.sort_values(x_label, ascending=True)
        fig = plt.Figure(figsize=(10.8,6.08),dpi=100)
        ax = fig.add_subplot(111)
        ax.barh(sort_df[y_label], sort_df[x_label])
        ax.set_title(title)
        ax.set_xlabel(x_label)
        ax.set_ylabel(y_label)
        canvas = FigureCanvasTkAgg(fig, master=self.content_frame)
        canvas.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=True)
    def create_time_grph(self,df , title, x_label, y_label):
        fig = plt.Figure(figsize=(10.8,6.08),dpi=100)
        ax = fig.add_subplot(111)

        sns.lineplot(data=df,ax=ax)
        ax.set_title(title)
        ax.set_xlabel(x_label)
        ax.set_ylabel(y_label)
        canvas = FigureCanvasTkAgg(fig, master=self.content_frame)
        canvas.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=True)
    def search_opt(self):
        self.canvas = tk.Canvas(self, width=1080, height=608, background='#D45438')
        self.canvas.pack(fill='both', expand=True)
        self.chname = tk.StringVar()
        self.searchBtn = ttk.Button(self.canvas, text="Search",command=self.search_name)
        chname = tk.Entry(self, width=40, textvariable=self.chname)
        chname.bind('<Return>',self.search_name)
        chname.place(x=400, y=304)
        self.searchBtn.place(x=660, y=304)
    def srch_grph1(self):
        self.scrollable_frame = ttk.Frame(self.parent)
        self.scrollable_frame.pack(fill=tk.BOTH, expand=True)
        self.canvas = tk.Canvas(self.scrollable_frame, width=1080, height=608)
        self.canvas.pack(side=tk.LEFT, fill=tk.BOTH, expand=True)
        self.scrollbar = ttk.Scrollbar(self.scrollable_frame, orient=tk.VERTICAL, command=self.canvas.yview)
        self.scrollbar.pack(side=tk.RIGHT, fill=tk.Y)
        self.canvas.configure(yscrollcommand=self.scrollbar.set)
        self.canvas.bind("<Configure>", lambda e: self.canvas.configure(scrollregion=self.canvas.bbox("all")))
        self.content_frame = ttk.Frame(self.canvas)
        self.canvas.create_window((0, 0), window=self.content_frame, anchor="nw")

        df = self.orig_df.copy()
        df['publish_time'] = pd.to_datetime(df['publish_time'])
        slcted_channel_df = df[df['channel_title'] == self.chname.get()]
        temp_df1 = slcted_channel_df.copy()
        temp_df1.index = pd.to_datetime(temp_df1['publish_time'], format='%Y%m%d')
        temp_df1['publish_time'] = pd.to_datetime(temp_df1['publish_time'], format='%Y%m%d')
        temp_df1 = temp_df1['views'].resample('A').mean()
        self.create_time_grph(temp_df1,'Average views over Years','Year','Views')
    def srch_grph2(self):
        self.scrollable_frame = ttk.Frame(self.parent)
        self.scrollable_frame.pack(fill=tk.BOTH, expand=True)
        self.canvas = tk.Canvas(self.scrollable_frame, width=1080, height=608)
        self.canvas.pack(side=tk.LEFT, fill=tk.BOTH, expand=True)
        self.scrollbar = ttk.Scrollbar(self.scrollable_frame, orient=tk.VERTICAL, command=self.canvas.yview)
        self.scrollbar.pack(side=tk.RIGHT, fill=tk.Y)
        self.canvas.configure(yscrollcommand=self.scrollbar.set)
        self.canvas.bind("<Configure>", lambda e: self.canvas.configure(scrollregion=self.canvas.bbox("all")))
        self.content_frame = ttk.Frame(self.canvas)
        self.canvas.create_window((0, 0), window=self.content_frame, anchor="nw")

        df = self.orig_df.copy()
        slcted_channel_df = df[df['channel_title'] == self.chname.get()]
        self.create_graph2(slcted_channel_df,'top viewed videos', 'views', 'title')
    def search_name(self,*args):
        pass
        _list = [str(x).lower() for x in self.orig_df['channel_title'].values]
        if self.chname.get().lower() in _list:
            print("match")
            self.canvas.destroy()
            self.backBtn.destroy()
            self.searched_tab()

        else:
            label = tk.Label(self.canvas, text="Not Found", background="#D45438", foreground="white" , font= "PrintAble4U, 30")
            label.place(x=400, y=350)
    def searched_tab(self):

        self.canvas = tk.Canvas(self, width=1080 , height = 608 , background='#D45438')
        self.canvas.pack(fill='both', expand = True)
        self.custom_style = ttk.Style()
        self.custom_style.configure("Custom.TButton", background="grey", foreground="white" , font="Ubuntu, 24 " , relief="flat")
        self.content_frame = ttk.Frame(self.canvas)
        self.create_widgets()
        self.backBtn = ttk.Button(self, text="Back", command=self.back1)
        self.backBtn.pack()
        # self.btnQuit = ttk.Button(self, text="Quit", command=self.parent.destroy)
    def back1(self):
        self.destroy()
        menu = Menu(self.parent)
        menu.run()
    def back2(self):
        self.destroy()
        self.scrollable_frame.destroy()
        menu = Menu(self.parent)
        menu.run()
    def get_cleaned_dataframe(self,df):
        temp_df = df.select_dtypes(include=['int', 'float']).copy()
        selected_var = temp_df.columns
        q1 = df[selected_var].quantile(0.25)
        q3 = df[selected_var].quantile(0.75)
        iqr = q3 - q1
        temp_df1 = df[~((df[selected_var] < q1 - 1.5 * iqr) | (df[selected_var] > q3 + 1.5 * iqr))]
        self.cleaned_df = temp_df1.dropna()
    def create_widgets(self):
        label1 = tk.Label(self.canvas, text=f"{self.chname.get()}'s stats",background="#D45438" , foreground="white",font= "PrintAble4U, 30")
        label1.place(x=415, y=50)
        button1 = ttk.Button(self.canvas, text="total views", command=self.total_views, style="Custom.TButton")
        button1.place(x=430, y=170)
        button2 = ttk.Button(self.canvas, text="videos views", command=self.videos_views, style="Custom.TButton")
        button2.place(x=430, y=450)
    def total_views(self):
        self.canvas.destroy()
        self.backBtn.destroy()
        self.srch_grph1()
        self.backBtn = ttk.Button(self, text="Back", command=self.back2)
        self.backBtn.pack()
    def videos_views(self):
        self.canvas.destroy()
        self.backBtn.destroy()
        self.srch_grph2()
        self.backBtn = ttk.Button(self, text="Back", command=self.back2)
        self.backBtn.pack()
